package by.zerg.layouteditor.gui;

import java.awt.Component;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

import by.zerg.layouteditor.theme.Property;
import by.zerg.layouteditor.theme.Section;

public class CustomTreeCellRenderer extends DefaultTreeCellRenderer {

	@Override
	public Component getTreeCellRendererComponent(JTree tree, Object value,
			boolean selected, boolean expanded, boolean leaf, int row,
			boolean hasFocus) {
		Component returnValue = null;
		if ((value != null) && (value instanceof DefaultMutableTreeNode)) {
			Object userObject = ((DefaultMutableTreeNode) value)
					.getUserObject();
			if (userObject instanceof Section) {
				returnValue = super.getTreeCellRendererComponent(tree,
						userObject.toString(), selected, expanded, leaf, row,
						hasFocus);
			}
			if (userObject instanceof Property) {
				returnValue = super.getTreeCellRendererComponent(tree,
						((Property) userObject).getName(), selected, expanded,
						leaf, row, hasFocus);
			}
		}
		if (returnValue == null) {
			returnValue = super.getTreeCellRendererComponent(tree, value,
					selected, expanded, leaf, row, hasFocus);
		}
		return returnValue;
	}
}
