package by.zerg.layouteditor.theme;

import static by.zerg.layouteditor.helpers.Constants.LEFT_SQUARE_BRACKET;
import static by.zerg.layouteditor.helpers.Constants.RIGHT_SQUARE_BRACKET;

import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.Map;

public class Section {
	final String name;
	final Config config;
	Map<String, Property> properties;

	public Section(String name, Config config) {
		this.name = name;
		this.config = config;
		properties = new LinkedHashMap<String, Property>();
	}

	@Override
	public String toString() {
		return LEFT_SQUARE_BRACKET + name + RIGHT_SQUARE_BRACKET;
	}

	public void addProperty(Property property) {
		properties.put(property.getName(), property);
	}

	public Property getProperty(String name) {
		Property property = properties.get(name);
		// if (property == null && config.getTheme().getBaseTheme() != null) {
		// try {
		// config.getTheme().getBaseTheme().getConfig().decrypt();
		// } catch (IOException e) {
		// // TODO Auto-generated catch block
		// e.printStackTrace();
		// }
		// property = config.getTheme().getBaseTheme().getConfig()
		// .getSection(this.name).getProperty(name);
		// }
		return property;
	}

	public String getPropertyValue(String name) {
		Property property = getProperty(name);
		String value = null;
		if (property != null) {
			value = property.getValue();
		}
		return value;
	}

	public Map<String, Property> getProperties() {
		return properties;
	}

	public void setProperties(Map<String, Property> properties) {
		this.properties = properties;
	}

	public Config getConfig() {
		return config;
	}

	public String getName() {
		return name;
	}
}
